
import processing.serial.*;
import controlP5.*;

ControlP5 controlP5;
PFont font;
ListBox l;

Serial myPort;  // Create object from Serial class
String value;      // Data received from the serial port
String tempv;
public static final char CR = 13;     // ASCII linefeed

void setup() 
{
  size(700, 700);
  // I know that the first port in the serial list on my mac
  // is always my  FTDI adaptor, so I open Serial.list()[0].
  // On Windows machines, this generally opens COM1.
  // Open whatever port is the one you're using.
  String portName = Serial.list()[0];
  myPort = new Serial(this, portName, 9600);
  
  font = createFont("Arial", 200, true); 
  textFont(font); 
  
  ///setup list
   controlP5 = new ControlP5(this);
  l = controlP5.addListBox("myList",5,20,200,120);
  l.setItemHeight(15);
  l.setBarHeight(15);

  l.captionLabel().toUpperCase(true);
  l.captionLabel().set("Serial/USB ports");
  l.captionLabel().style().marginTop = 3;
  l.valueLabel().style().marginTop = 3; // the +/- sign
  //l.setBackgroundColor(color(100,0,0));
  for(int i=0;i<Serial.list().length;i++) {
    l.addItem(Serial.list()[i],i);
  }
  l.setColorBackground(color(255,128));
  l.setColorActive(color(0,0,255,128));
  
  value = "\n\r";
  tempv = "\n\r";
}

void draw()
{
  background(30,70,30); 
  if ( myPort.available() > 0) {  // If data is available,
    char val = char(myPort.read());         // read it and store it in val
    if(val == CR) {
       value = tempv;
       tempv = "";
    } else {
       tempv += val;
    }
  }
  
   textAlign(CENTER);
   fill(200);
   textSize(200);
   text(value, 350, 100);
   
   textAlign(LEFT);
   fill(200);
   textSize(10);
   text("The default port is the first on the list. Choose another port if you know what you're doing.", 220, 9,150,500);
   
        
 
}


void controlEvent(ControlEvent theEvent) {
  // ListBox is if type ControlGroup.
  // 1 controlEvent will be executed, where the event
  // originates from a ControlGroup. therefore
  // you need to check the Event with
  // if (theEvent.isGroup())
  // to avoid an error message from controlP5.
  
  if (theEvent.isGroup()) {
    // an event from a group e.g. scrollList
   int portIndex = (int) theEvent.group().value();
    myPort = new Serial(this, Serial.list()[portIndex], 9600);

  }
}

